%define Werror_cflags -Wformat -fpermissive -Wextra -Wall -Wno-unused -Wno-deprecated

%define build_java 1
%define build_autotools 1

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_java: %{expand: %%global build_java 1}}
%{?_without_java: %{expand: %%global build_java 0}}
%{?_with_autotools: %{expand: %%global build_autotools 1}}
%{?_without_autotools: %{expand: %%global build_autotools 0}}

Summary:	Extensible modeling tool for MySQL 5.x
Name:		mysql-workbench-oss
Group:		Databases
Version:	5.2.33
Release:	%mkrel 4
License:	GPL
URL:		http://dev.mysql.com/downloads/workbench/
# ftp://ftp.pbone.net/mirror/dev.mysql.com/pub/Downloads/MySQLGUITools/mysql-workbench-5.1.4-1fc9.src.rpm
Source0:	http://dev.mysql.com/get/Downloads/MySQLGUITools/mysql-workbench-gpl-%{version}b-src.tar.gz
Patch0:	        mysql-workbench-gpl-5.2.33-use_-avoid-version_for_plugins.patch
Patch1:	        mysql-workbench-gpl-5.2.33-linkage.patch
Patch2:		mysql-workbench-5.2.33-gcc46.patch
Patch3:		mysql-workbench-gpl-5.2.33-get_admin_script_for_os-prototype-and-string-as-reference.patch
Obsoletes:	mysql-workbench < 5.1.6
Provides:	mysql-workbench
BuildRequires:	autoconf2.5
BuildRequires:	boost-devel >= 1.35.0
BuildRequires:	cairo-devel
BuildRequires:	cairomm-devel
BuildRequires:	ctemplate-devel >= 0.91
BuildRequires:	expat-devel
BuildRequires:	fdupes
BuildRequires:	file
BuildRequires:  freetype2-devel >= 2.1.10
BuildRequires:	gettext
BuildRequires:	gettext-devel
BuildRequires:	glib2-devel
BuildRequires:	glibmm2.4-devel
BuildRequires:	glitz-devel
BuildRequires:	gtk2-devel
BuildRequires:	gtkhtml-3.14-devel
BuildRequires:	gtkmm2.4-devel >= 2.6
BuildRequires:	imagemagick
BuildRequires:	libext2fs-devel
BuildRequires:	libfcgi-devel
BuildRequires:	libfontconfig-devel
BuildRequires:	libglade2.0-devel >= 2.5
BuildRequires:	libgnome2-devel
BuildRequires:	libgnomeprint-devel >= 2.2.0
BuildRequires:	libpng-devel
BuildRequires:	libsigc++2.0-devel
BuildRequires:	libslang-devel
BuildRequires:	libtool
BuildRequires:	libuuid-devel
BuildRequires:  libx11-devel
BuildRequires:  libxext-devel
BuildRequires:	libxml2-devel
BuildRequires:	libxrender-devel
BuildRequires:	libzip-devel
BuildRequires:	lua5.1-devel
BuildRequires:	mesagl-devel
BuildRequires:	mesaglu-devel
BuildRequires:	mysql-connector-c++-devel
BuildRequires:	mysql-devel >= 5.0
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:	pcre-devel >= 5.0
BuildRequires:  pixman-devel >= 0.11.2
BuildRequires:	pkgconfig
BuildRequires:	python-devel
BuildRequires:	readline-devel
BuildRequires:	scintilla-devel
BuildRequires:	termcap-devel
BuildRequires:	sqlite3-devel
BuildRequires:	libgnome-keyring-devel
%if %{build_java}
BuildRequires:  junit
BuildRequires:	eclipse-ecj
BuildRequires:  gcj-tools
BuildRequires:  jpackage-utils
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires:	python-paramiko

%description
MySQL Workbench is modeling tool that allows you to design and generate MySQL
databases graphically.

MySQL Workbench requires OpenGL and a 3D accelerated graphics card with at
least 16MB of memory.

%prep

%setup -q -n mysql-workbench-gpl-%{version}-src
%patch0 -p1 -b .module~
%patch1 -p1 -b .link~
%patch2 -p1 -b .gcc46~
%patch3 -p1 -b .str_reference~

# lib64 fix
perl -pi -e "s|/lib/|/%{_lib}/|g" frontend/linux/workbench/program.cpp

# other small fixes
#touch po/POTFILES.in

# ctemplete is now ctemplate and not google anymore
for i in `grep -Rl google .`; do
    sed -i 's/google/ctemplate/g' $i;
done

%build
#export CPPFLAGS="$CPPFLAGS `pkg-config --cflags scintilla`"

%if %{build_autotools}
NOCONFIGURE=yes ./autogen.sh
%endif
%define _disable_ld_no_undefined 1
%configure2_5x --disable-static

# antibork
#find -type f -name Makefile | xargs perl -pi -e "s|-Wl,--as-needed||g"

# use the shared libs
#find -type f -name Makefile | xargs perl -pi -e "s|%{_libdir}/python%{pyver}/config/libpython%{pyver}.a|-lpython%{pyver}|g"

make

%install
rm -rf %{buildroot}

%makeinstall_std

# construct a clean and correct wrapper
cat > %{buildroot}%{_bindir}/mysql-workbench << EOF
#!/bin/bash
export LD_LIBRARY_PATH="%{_libdir}/mysql-workbench:\$LD_LIBRARY_PATH"
export MWB_DATA_DIR="%{_datadir}/mysql-workbench"
export MWB_LIBRARY_DIR="%{_datadir}/mysql-workbench/libraries"
export MWB_MODULE_DIR="%{_libdir}/mysql-workbench/modules"
export MWB_PLUGIN_DIR="%{_libdir}/mysql-workbench/plugins"
export DBC_DRIVER_PATH="%{_libdir}/mysql-workbench"
%{_bindir}/mysql-workbench-bin \$*
EOF

# fix some menu entries and stuff...
install -d %{buildroot}%{_miconsdir}
install -d %{buildroot}%{_iconsdir}
install -d %{buildroot}%{_liconsdir}

install -d %{buildroot}%{_datadir}/applications
rm -f %{buildroot}%{_datadir}/applications/MySQLWorkbench.desktop
cat > %{buildroot}%{_datadir}/applications/mysql-workbench-oss.desktop << EOF
[Desktop Entry]
Name=MySQL Workbench
Comment=MySQL Database Design Tool
Exec=%{_bindir}/mysql-workbench
Terminal=false
Type=Application
Icon=mysql-workbench
Categories=Database;Office;
EOF

# make some icons
convert %{buildroot}%{_datadir}/mysql-workbench/images/MySQLWorkbench-48.png -resize 16x16 %{buildroot}%{_miconsdir}/mysql-workbench.png
convert %{buildroot}%{_datadir}/mysql-workbench/images/MySQLWorkbench-48.png -resize 32x32 %{buildroot}%{_iconsdir}/mysql-workbench.png
convert %{buildroot}%{_datadir}/mysql-workbench/images/MySQLWorkbench-48.png -resize 48x48 %{buildroot}%{_liconsdir}/mysql-workbench.png

# cleanup
rm -f %{buildroot}%{_libdir}/mysql-workbench/*.*a
rm -f %{buildroot}%{_libdir}/mysql-workbench/lib*.so
rm -f %{buildroot}%{_libdir}/mysql-workbench/modules/*.*a
rm -f %{buildroot}%{_libdir}/mysql-workbench/plugins/*.*a

%if %mdkversion < 200900
%post
%update_menus
%endif

%if %mdkversion < 200900
%postun
%clean_menus
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc COPYING ChangeLog README
%{_bindir}/*
%{_libdir}/mysql-workbench/lib*.so.*
%{_libdir}/mysql-workbench/mysqlcppconn.so
/usr/share/doc/mysql-workbench/COPYING
/usr/share/doc/mysql-workbench/README
%{_libdir}/mysql-workbench/modules
%{_libdir}/mysql-workbench/plugins
%{_datadir}/mysql-workbench
%{_datadir}/applications/mysql-workbench-oss.desktop
%{_iconsdir}/mysql-workbench.png
%{_liconsdir}/mysql-workbench.png
%{_miconsdir}/mysql-workbench.png


%changelog
* Wed Jun 29 2011 Luis Daniel Lucio Quiroz <dlucio@mandriva.org> 5.2.33-4mdv2011.0
+ Revision: 688182
- python-paramiko as require for SSH tunneling

* Wed May 25 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 5.2.33-3
+ Revision: 678987
- add a prototype for get_admini_script_os() in api, and be sure to pass strings
  as references to it (P3)

  + Luis Daniel Lucio Quiroz <dlucio@mandriva.org>
    - P2  to let pass a gcc46 restriction

  + Leonardo Coelho <leonardoc@mandriva.com>
    - add old patch
    - version updated

  + Funda Wang <fwang@mandriva.org>
    - there is no vsqlite++

  + Oden Eriksson <oeriksson@mandriva.com>
    - rebuilt against libzip.so.2
    - 5.2.31(a)

* Mon Sep 13 2010 Funda Wang <fwang@mandriva.org> 5.2.27-1mdv2011.0
+ Revision: 577844
- add more BRs
- update file list
- more patch
- rediff plugin patch
- New version 5.2.27
- rebuild

* Thu Feb 18 2010 Oden Eriksson <oeriksson@mandriva.com> 5.1.16-3mdv2010.1
+ Revision: 507890
- sync some ideas from opensuse
- fix build
- fix deps (libuuid-devel)
- rebuild

* Sun Jul 19 2009 Raphaël Gertz <rapsys@mandriva.org> 5.1.16-2mdv2010.0
+ Revision: 397475
- Remove useless ctemplate internal library

* Sun Jul 19 2009 Raphaël Gertz <rapsys@mandriva.org> 5.1.16-1mdv2010.0
+ Revision: 397255
- New version 5.1.16
  Remove internal libraries
  Fix startup script

* Mon Apr 20 2009 Raphaël Gertz <rapsys@mandriva.org> 5.1.10-1mdv2009.1
+ Revision: 368108
- New release 5.1.10 (beta2)
  Fix desktop file to avoid mysql-workbench in developement

* Mon Feb 23 2009 Raphaël Gertz <rapsys@mandriva.org> 5.1.7-1mdv2009.1
+ Revision: 344113
- Cleanup of spec file
- Add the missing provides required by package name change

* Mon Feb 23 2009 Raphaël Gertz <rapsys@mandriva.org> 5.1.7-0.1mdv2009.1
+ Revision: 344071
- Fit new upstream sun package official name
- New version 5.1.7
  Fix build
  Rename to sun new product name mysql-workbench-oss

* Sun Dec 28 2008 Funda Wang <fwang@mandriva.org> 5.1.5-0.2mdv2009.1
+ Revision: 320232
- fix patch
- more patches
- fix str fmt
- do not run configure twice
- rebuild for new python

* Mon Dec 15 2008 Oden Eriksson <oeriksson@mandriva.com> 5.1.5-0.1mdv2009.1
+ Revision: 314500
- more -avoid-version fixes
- fix build
- 5.1.5 (alpha)
- rediffed P0

* Fri Nov 07 2008 Oden Eriksson <oeriksson@mandriva.com> 5.1.4-0.1mdv2009.1
+ Revision: 300694
- import mysql-workbench

